From e2e7bc3c9ed932dfd08a589ab782f591fd8d80b7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 18 2020 22:17:37 +0000
Subject: [PATCH 176/2232] Update to codespan-reporting 0.9


---

diff --git a/BUCK b/BUCK
index 2f80c9b..4357dd6 100644
--- a/BUCK
+++ b/BUCK
@@ -7,7 +7,6 @@ rust_library(
         ":macro",
         "//third-party:anyhow",
         "//third-party:cc",
-        "//third-party:codespan",
         "//third-party:codespan-reporting",
         "//third-party:link-cplusplus",
         "//third-party:proc-macro2",
@@ -26,7 +25,6 @@ rust_binary(
     },
     deps = [
         "//third-party:anyhow",
-        "//third-party:codespan",
         "//third-party:codespan-reporting",
         "//third-party:proc-macro2",
         "//third-party:quote",
diff --git a/BUILD b/BUILD
index db22203..59ac9fc 100644
--- a/BUILD
+++ b/BUILD
@@ -10,7 +10,6 @@ rust_library(
         ":cxxbridge-macro",
         "//third-party:anyhow",
         "//third-party:cc",
-        "//third-party:codespan",
         "//third-party:codespan-reporting",
         "//third-party:link-cplusplus",
         "//third-party:proc-macro2",
@@ -27,7 +26,6 @@ rust_binary(
     visibility = ["//visibility:public"],
     deps = [
         "//third-party:anyhow",
-        "//third-party:codespan",
         "//third-party:codespan-reporting",
         "//third-party:proc-macro2",
         "//third-party:quote",
diff --git a/Cargo.toml b/Cargo.toml
index 8432bc7..63a3a94 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -17,8 +17,7 @@ travis-ci = { repository = "dtolnay/cxx" }
 [dependencies]
 anyhow = "1.0"
 cc = "1.0.49"
-codespan = "0.7"
-codespan-reporting = "0.7"
+codespan-reporting = "0.9"
 cxxbridge-macro = { version = "=0.2.0", path = "macro" }
 link-cplusplus = "1.0"
 proc-macro2 = { version = "1.0", features = ["span-locations"] }
diff --git a/cmd/Cargo.toml b/cmd/Cargo.toml
index 7ee974c..aef31f6 100644
--- a/cmd/Cargo.toml
+++ b/cmd/Cargo.toml
@@ -16,8 +16,7 @@ travis-ci = { repository = "dtolnay/cxx" }
 
 [dependencies]
 anyhow = "1.0"
-codespan = "0.7"
-codespan-reporting = "0.7"
+codespan-reporting = "0.9"
 proc-macro2 = { version = "1.0", features = ["span-locations"] }
 quote = "1.0"
 structopt = "0.3"
diff --git a/gen/error.rs b/gen/error.rs
index b8ac337..ca78acb 100644
--- a/gen/error.rs
+++ b/gen/error.rs
@@ -1,8 +1,8 @@
 use crate::gen::Error;
 use crate::syntax;
 use anyhow::anyhow;
-use codespan::{FileId, Files};
 use codespan_reporting::diagnostic::{Diagnostic, Label};
+use codespan_reporting::files::SimpleFiles;
 use codespan_reporting::term::termcolor::{ColorChoice, StandardStream, WriteColor};
 use codespan_reporting::term::{self, Config};
 use std::io::Write;
@@ -46,32 +46,30 @@ fn display_syn_error(stderr: &mut dyn WriteColor, path: &Path, source: &str, err
     }
     end_offset += end.column;
 
-    let mut files = Files::new();
+    let mut files = SimpleFiles::new();
     let file = files.add(path.to_string_lossy(), source);
 
-    let range = start_offset as u32..end_offset as u32;
-    let diagnostic = diagnose(file, range, error);
+    let diagnostic = diagnose(file, start_offset..end_offset, error);
 
     let config = Config::default();
     let _ = term::emit(stderr, &config, &files, &diagnostic);
 }
 
-fn diagnose(file: FileId, range: Range<u32>, error: syn::Error) -> Diagnostic {
+fn diagnose(file: usize, range: Range<usize>, error: syn::Error) -> Diagnostic<usize> {
     let message = error.to_string();
     let info = syntax::error::ERRORS
         .iter()
         .find(|e| message.contains(e.msg));
-    let mut diagnostic = if let Some(info) = info {
-        let label = Label::new(file, range, info.label.unwrap_or(&message));
-        let mut diagnostic = Diagnostic::new_error(&message, label);
-        if let Some(note) = info.note {
-            diagnostic = diagnostic.with_notes(vec![note.to_owned()]);
-        }
-        diagnostic
+    let mut diagnostic = Diagnostic::error().with_message(&message);
+    let mut label = Label::primary(file, range);
+    if let Some(info) = info {
+        label.message = info.label.map_or(message, str::to_owned);
+        diagnostic.labels.push(label);
+        diagnostic.notes.extend(info.note.map(str::to_owned));
     } else {
-        let label = Label::new(file, range, &message);
-        Diagnostic::new_error(&message, label)
-    };
+        label.message = message;
+        diagnostic.labels.push(label);
+    }
     diagnostic.code = Some("cxxbridge".to_owned());
     diagnostic
 }
diff --git a/third-party/BUCK b/third-party/BUCK
index ccb2107..14f2542 100644
--- a/third-party/BUCK
+++ b/third-party/BUCK
@@ -30,18 +30,10 @@ rust_library(
 )
 
 rust_library(
-    name = "codespan",
-    srcs = glob(["vendor/codespan-0.7.0/src/**"]),
-    visibility = ["PUBLIC"],
-    deps = [":unicode-segmentation"],
-)
-
-rust_library(
     name = "codespan-reporting",
-    srcs = glob(["vendor/codespan-reporting-0.7.0/src/**"]),
+    srcs = glob(["vendor/codespan-reporting-0.9.0/src/**"]),
     visibility = ["PUBLIC"],
     deps = [
-        ":codespan",
         ":termcolor",
         ":unicode-width",
     ],
diff --git a/third-party/BUILD b/third-party/BUILD
index ad779fd..daf9ea1 100644
--- a/third-party/BUILD
+++ b/third-party/BUILD
@@ -35,18 +35,10 @@ rust_library(
 )
 
 rust_library(
-    name = "codespan",
-    srcs = glob(["vendor/codespan-0.7.0/src/**"]),
-    visibility = ["//visibility:public"],
-    deps = [":unicode-segmentation"],
-)
-
-rust_library(
     name = "codespan-reporting",
-    srcs = glob(["vendor/codespan-reporting-0.7.0/src/**"]),
+    srcs = glob(["vendor/codespan-reporting-0.9.0/src/**"]),
     visibility = ["//visibility:public"],
     deps = [
-        ":codespan",
         ":termcolor",
         ":unicode-width",
     ],
